// XmlFile.cpp: Implementierung der Klasse CXmlFile.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "XmlFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CXmlFile::CXmlFile()
{

}

CXmlFile::~CXmlFile()
{

}

BOOL CXmlFile::read2Buf(CString pfad)
{
	CFile gpxFile;
	if(gpxFile.Open(pfad,CFile::modeRead)==0)
/*	{
		CString txt;
		txt.Format("Can't open %s",pfad);
		AfxMessageBox(txt);
*/		return FALSE;
//	}
	m_fileLen=gpxFile.GetLength();
	char *buf=m_sBuf.GetBuffer(m_fileLen+1);
	gpxFile.ReadHuge(buf,m_fileLen);	 //ganzes File laden
	gpxFile.Close();
	buf[m_fileLen]='\0';
	m_sBuf.ReleaseBuffer();
	return TRUE;
}

CString CXmlFile::readVal(CString &quell,CString tag, int *pPos,CString *attr,int opt)
{
	int startPos=0;
	if(pPos)
		startPos=*pPos;
	CString ret="",start;
	start.Format("<%s>",tag);
	int pos=quell.Find(start,startPos),posAttr=-1;
	if(pos==-1)
	{
		start.Format("<%s ",tag);
		pos=quell.Find(start,startPos);
		if(pos==-1)
		{
			start.Format("<%s\t",tag);
			pos=quell.Find(start,startPos);
		}
		if(pos>-1)
			posAttr=pos+start.GetLength();
	} 
	if(pos>-1)
	{
		CString end;
		end.Format("</%s>",tag);
		int posE=quell.Find(end,pos);
		if(posE>-1)
		{
			int posVal=quell.Find(">",pos)+1;
			ret=quell.Mid(posVal,posE-posVal);
			if(pPos)
				*pPos=posE+end.GetLength();
			if(attr)
			{
				if(posAttr>-1)
					*attr=quell.Mid(posAttr,posVal-posAttr-1);
				else
					*attr="";
			}
		}
	}
	if(!ret.Left(1).Compare("\"") && !ret.Right(1).Compare("\""))
	{
		ret.Delete(0);
		ret.Delete(ret.GetLength()-1);
	}
	if((opt&ELIM_TAGS)>0)
		elimAllTags(ret);
	if((opt&TRIM_LEFT)>0)
		ret.TrimLeft("\t \r\n");
	if((opt&TRIM_RIGHT)>0)
		ret.TrimRight("\t \r\n");
	return ret;

}

int CXmlFile::readVal_intDef(CString &quell, CString tag, int def,int *start)
{
	CString val=readVal(quell,tag,start,NULL,TRIM|ELIM_TAGS);
	if(val.IsEmpty())
		return def;
	else
	{
		char *rest;
		return (int)strtol(val,&rest,0);
	}

}

CString CXmlFile::readVal(CString tag, int *start,CString *attr,int opt)
{
	return readVal(m_sBuf,tag,start,attr,opt);
}





double CXmlFile::readAttrValD(CString quell, CString name)
{
	int pos=quell.Find(name);
	double ret=	DBL_MAX;

	if(pos>-1)
	{
		pos+=name.GetLength();
		pos+=quell.Mid(pos).FindOneOf(".0123456789");
		ret=atof(quell.Mid(pos));
	}
	return ret;

}

CString CXmlFile::readAttr(CString tag, int *start)
{
	return readAttr(m_sBuf,tag,start);
}

CString CXmlFile::readAttr(CString &quell, CString tag, int *pPos)
{
	int startPos=0;
	if(pPos)
		startPos=*pPos;
	CString ret="",start;
	start.Format("<%s>",tag);
	int pos=quell.Find(start,startPos),posAttr=-1;
	if(pos==-1)
	{
		start.Format("<%s ",tag);
		pos=quell.Find(start,startPos);
		if(pos==-1)
		{
			start.Format("<%s\t",tag);
			pos=quell.Find(start,startPos);
		}
		if(pos>-1)
			posAttr=pos+start.GetLength();
	} 
	if(pos>-1)
	{
		CString end;
		end.Format("</%s>",tag);
		int posE=quell.Find(end,pos);
		if(posE>-1)
		{
			int posVal=quell.Find(">",pos)+1;
			if(pPos)
				*pPos=posE+end.GetLength();
			if(posAttr>-1)
				ret=quell.Mid(posAttr,posVal-posAttr-1);
			else
				ret="";
		}
	}
	return ret;

}

double CXmlFile::readVal_dblDef(CString &quell, CString tag, double def)
{
	CString val=readVal(quell,tag);
	if(val.IsEmpty())
		return def;
	else
		return atof(val);

}

void CXmlFile::elimAllTags(CString &str)
{
	int idxS,idxE;
	while((idxS=str.ReverseFind('<'))>-1)
	{
		idxE=str.Find('>',idxS);
		if(idxE==-1)
			break;
		str.Delete(idxS,idxE-idxS+1);
	}
}
